
/*
 *  NoNameFS
 *
 *  Copyright (C) 2009 Mike Evans 
 *
 *  NoNameFS has been written to provike discussion on how 
 *  file system naming could be improved so as to be more usable
 *  by human beings.
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Authors: Mike Evans <mike@tandem.f9.co.uk>
 *
 */
#ifndef MODEL_H_
#define MODEL_H_

#endif /*MODEL_H_*/

#include <gnome.h>
#include <mysql.h>


enum {
	COLUMN_1,
	COLUMN_2,
	COLUMN_3,
	COLUMN_4,
	COLUMN_5,
	COLUMN_6,
	COLUMN_7,
	N_COLUMNS
};

#define TAG_NAME_LEN	31
#define TAG_DATA_LEN	101
#define TAG_ID_LEN      11
#define TAG_DATA_TYPE_LEN 11
#define FILE_ACT_NAME_LEN 201
#define FILE_NAME_LEN   51
#define FILE_ID_LEN 51
#define FILE_MAX_TAGS 100
#define FILE_UNUSED_HEADER_LEN 100
#define STATE_MAX_CURRENT_TAGS 20
#define STATE_MAX_POSS_TAGS 100
#define STATE_MAX_HEADING_TAGS 20
#define STATE_MAX_SELECTED_FILES 100

typedef struct tag_struct {
	char name[TAG_NAME_LEN];
	char data[TAG_DATA_LEN];
	char data_type[TAG_DATA_TYPE_LEN];
	int  cardinality;
	int  priority;
	short  used_header;
	char id[TAG_ID_LEN];
} tag;

typedef struct selected_file_struct {
	char actual_name[FILE_ACT_NAME_LEN];
	char name[FILE_NAME_LEN];
	char id[FILE_ID_LEN]; 
	int  tag_count;
	tag  tags[FILE_MAX_TAGS];
	char unused_headers[FILE_UNUSED_HEADER_LEN];
} selected_file;

// this should be tidied up by making them arrays of pointers and mallocing new 
// as required....
typedef struct tagfs_state_struct {
	MYSQL 	*database_connection1;
	MYSQL   *database_connection2;
	int		current_tag_count;
	tag		current_tags[STATE_MAX_CURRENT_TAGS];
	int     possible_tag_count;
	tag		possible_tags[STATE_MAX_POSS_TAGS];
	int     heading_tag_count;
	tag     heading_tags[STATE_MAX_HEADING_TAGS];
	int 	selected_file_count;
	selected_file selected_files[STATE_MAX_SELECTED_FILES];
	int		current_view_columns; 
	int		current_cursor_index;
} tagfs_state;



/* prototypes */

GtkListStore *model_new(void);
tagfs_state *tagfs_state_new();
void tagfs_state_free(tagfs_state *old);
char * parse_word(char *line, char *word, int max_chars);
int str_contains(char *str1, char *str2);
int file_has_tag ( selected_file *the_file, tag *the_tag );
void update_suggested_model(tagfs_state *state, GtkListStore *liststore );

